/* main-toolbar.c generated by valac 0.48.2, the Vala compiler
 * generated from main-toolbar.vala, do not modify */

/* Copyright 2017 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Draws the main toolbar.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <handy.h>
#include "geary-engine.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define TYPE_MAIN_TOOLBAR (main_toolbar_get_type ())
#define MAIN_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_TOOLBAR, MainToolbar))
#define MAIN_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_TOOLBAR, MainToolbarClass))
#define IS_MAIN_TOOLBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_TOOLBAR))
#define IS_MAIN_TOOLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_TOOLBAR))
#define MAIN_TOOLBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_TOOLBAR, MainToolbarClass))

typedef struct _MainToolbar MainToolbar;
typedef struct _MainToolbarClass MainToolbarClass;
typedef struct _MainToolbarPrivate MainToolbarPrivate;

#define TYPE_FOLDER_POPOVER (folder_popover_get_type ())
#define FOLDER_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FOLDER_POPOVER, FolderPopover))
#define FOLDER_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FOLDER_POPOVER, FolderPopoverClass))
#define IS_FOLDER_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FOLDER_POPOVER))
#define IS_FOLDER_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FOLDER_POPOVER))
#define FOLDER_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FOLDER_POPOVER, FolderPopoverClass))

typedef struct _FolderPopover FolderPopover;
typedef struct _FolderPopoverClass FolderPopoverClass;
enum  {
	MAIN_TOOLBAR_0_PROPERTY,
	MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY,
	MAIN_TOOLBAR_ACCOUNT_PROPERTY,
	MAIN_TOOLBAR_FOLDER_PROPERTY,
	MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY,
	MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY,
	MAIN_TOOLBAR_FIND_OPEN_PROPERTY,
	MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY,
	MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY,
	MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY,
	MAIN_TOOLBAR_NUM_PROPERTIES
};
static GParamSpec* main_toolbar_properties[MAIN_TOOLBAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define APPLICATION_TYPE_CONFIGURATION (application_configuration_get_type ())
#define APPLICATION_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_CONFIGURATION, ApplicationConfiguration))
#define APPLICATION_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_CONFIGURATION, ApplicationConfigurationClass))
#define APPLICATION_IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_CONFIGURATION))
#define APPLICATION_IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_CONFIGURATION))
#define APPLICATION_CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_CONFIGURATION, ApplicationConfigurationClass))

typedef struct _ApplicationConfiguration ApplicationConfiguration;
typedef struct _ApplicationConfigurationClass ApplicationConfigurationClass;
typedef enum  {
	APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN = 0,
	APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY
} ApplicationConfigurationDesktopEnvironment;

#define APPLICATION_CONFIGURATION_TYPE_DESKTOP_ENVIRONMENT (application_configuration_desktop_environment_get_type ())

struct _MainToolbar {
	GtkBox parent_instance;
	MainToolbarPrivate * priv;
	GtkMenuButton* copy_message_button;
	GtkMenuButton* move_message_button;
};

struct _MainToolbarClass {
	GtkBoxClass parent_class;
};

struct _MainToolbarPrivate {
	gint _left_pane_width;
	gchar* _account;
	gchar* _folder;
	gboolean _show_close_button;
	gboolean _search_open;
	gboolean _find_open;
	FolderPopover* _copy_folder_menu;
	FolderPopover* _move_folder_menu;
	gint _selected_conversations;
	GtkHeaderBar* folder_header;
	GtkToggleButton* search_conversations_button;
	GtkMenuButton* main_menu_button;
	GtkHeaderBar* conversation_header;
	GtkMenuButton* mark_message_button;
	GtkButton* archive_button;
	GtkButton* trash_delete_button;
	GtkToggleButton* find_button;
	HdyHeaderGroup* header_group;
	gboolean show_trash_button;
	GtkImage* trash_image;
	GtkImage* delete_image;
};

static gint MainToolbar_private_offset;
static gpointer main_toolbar_parent_class = NULL;

GType main_toolbar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainToolbar, g_object_unref)
GType folder_popover_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FolderPopover, g_object_unref)
FolderPopover* folder_popover_new (void);
FolderPopover* folder_popover_construct (GType object_type);
GType application_configuration_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ApplicationConfiguration, g_object_unref)
MainToolbar* main_toolbar_new (ApplicationConfiguration* config);
MainToolbar* main_toolbar_construct (GType object_type,
                                     ApplicationConfiguration* config);
void application_configuration_bind (ApplicationConfiguration* self,
                                     const gchar* key,
                                     GObject* object,
                                     const gchar* property,
                                     GSettingsBindFlags flags);
#define APPLICATION_CONFIGURATION_MESSAGES_PANE_POSITION_KEY "messages-pane-position"
GType application_configuration_desktop_environment_get_type (void) G_GNUC_CONST;
ApplicationConfigurationDesktopEnvironment application_configuration_get_desktop_environment (ApplicationConfiguration* self);
static void __lambda24_ (MainToolbar* self);
static void main_toolbar_update_conversation_buttons (MainToolbar* self);
static void ___lambda24__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
FolderPopover* main_toolbar_get_copy_folder_menu (MainToolbar* self);
FolderPopover* main_toolbar_get_move_folder_menu (MainToolbar* self);
void main_toolbar_set_conversation_header (MainToolbar* self,
                                           GtkHeaderBar* header);
void main_toolbar_remove_conversation_header (MainToolbar* self,
                                              GtkHeaderBar* header);
void main_toolbar_update_trash_button (MainToolbar* self,
                                       gboolean show_trash);
gint main_toolbar_get_selected_conversations (MainToolbar* self);
gchar* action_window_prefix (const gchar* action_name);
#define APPLICATION_MAIN_WINDOW_ACTION_TRASH_CONVERSATION "trash-conversation"
#define APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION "delete-conversation"
gint main_toolbar_get_left_pane_width (MainToolbar* self);
void main_toolbar_set_left_pane_width (MainToolbar* self,
                                       gint value);
const gchar* main_toolbar_get_account (MainToolbar* self);
void main_toolbar_set_account (MainToolbar* self,
                               const gchar* value);
const gchar* main_toolbar_get_folder (MainToolbar* self);
void main_toolbar_set_folder (MainToolbar* self,
                              const gchar* value);
gboolean main_toolbar_get_show_close_button (MainToolbar* self);
void main_toolbar_set_show_close_button (MainToolbar* self,
                                         gboolean value);
gboolean main_toolbar_get_search_open (MainToolbar* self);
void main_toolbar_set_search_open (MainToolbar* self,
                                   gboolean value);
gboolean main_toolbar_get_find_open (MainToolbar* self);
void main_toolbar_set_find_open (MainToolbar* self,
                                 gboolean value);
static void main_toolbar_set_copy_folder_menu (MainToolbar* self,
                                        FolderPopover* value);
static void main_toolbar_set_move_folder_menu (MainToolbar* self,
                                        FolderPopover* value);
void main_toolbar_set_selected_conversations (MainToolbar* self,
                                              gint value);
static void main_toolbar_finalize (GObject * obj);
static GType main_toolbar_get_type_once (void);
static void _vala_main_toolbar_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_main_toolbar_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
main_toolbar_get_instance_private (MainToolbar* self)
{
	return G_STRUCT_MEMBER_P (self, MainToolbar_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda24_ (MainToolbar* self)
{
	main_toolbar_update_conversation_buttons (self);
}

static void
___lambda24__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda24_ ((MainToolbar*) self);
}

MainToolbar*
main_toolbar_construct (GType object_type,
                        ApplicationConfiguration* config)
{
	MainToolbar * self = NULL;
	GtkHeaderBar* _tmp0_;
	ApplicationConfigurationDesktopEnvironment _tmp1_;
	ApplicationConfigurationDesktopEnvironment _tmp2_;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp5_;
	GMenuModel* main_menu = NULL;
	GObject* _tmp6_;
	GMenuModel* _tmp7_;
	GMenuModel* mark_menu = NULL;
	GObject* _tmp8_;
	GMenuModel* _tmp9_;
	GtkMenuButton* _tmp10_;
	GtkPopover* _tmp11_;
	GtkPopover* _tmp12_;
	GtkToggleButton* _tmp13_;
	GtkMenuButton* _tmp14_;
	GtkPopover* _tmp15_;
	GtkPopover* _tmp16_;
	GtkMenuButton* _tmp17_;
	FolderPopover* _tmp18_;
	GtkMenuButton* _tmp19_;
	FolderPopover* _tmp20_;
	GtkToggleButton* _tmp21_;
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (config), NULL);
	self = (MainToolbar*) g_object_new (object_type, NULL);
	application_configuration_bind (config, APPLICATION_CONFIGURATION_MESSAGES_PANE_POSITION_KEY, G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "left-pane-width", G_SETTINGS_BIND_GET);
	_tmp0_ = self->priv->folder_header;
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "left-pane-width", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, G_TYPE_OBJECT, GObject), "width-request", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp1_ = application_configuration_get_desktop_environment (config);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY) {
		GtkHeaderBar* _tmp3_;
		GtkHeaderBar* _tmp4_;
		_tmp3_ = self->priv->folder_header;
		g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "account", G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, G_TYPE_OBJECT, GObject), "title", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
		_tmp4_ = self->priv->folder_header;
		g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "folder", G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, G_TYPE_OBJECT, GObject), "subtitle", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	}
	_tmp5_ = gtk_builder_new_from_resource ("/org/gnome/Geary/main-toolbar-menus.ui");
	builder = _tmp5_;
	_tmp6_ = gtk_builder_get_object (builder, "main_menu");
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_menu_model_get_type (), GMenuModel));
	main_menu = _tmp7_;
	_tmp8_ = gtk_builder_get_object (builder, "mark_message_menu");
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_menu_model_get_type (), GMenuModel));
	mark_menu = _tmp9_;
	_tmp10_ = self->priv->main_menu_button;
	_tmp11_ = (GtkPopover*) gtk_popover_new_from_model (NULL, main_menu);
	g_object_ref_sink (_tmp11_);
	_tmp12_ = _tmp11_;
	gtk_menu_button_set_popover (_tmp10_, _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = self->priv->search_conversations_button;
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "search-open", G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, G_TYPE_OBJECT, GObject), "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::selected-conversations", (GCallback) ___lambda24__g_object_notify, self, 0);
	_tmp14_ = self->priv->mark_message_button;
	_tmp15_ = (GtkPopover*) gtk_popover_new_from_model (NULL, mark_menu);
	g_object_ref_sink (_tmp15_);
	_tmp16_ = _tmp15_;
	gtk_menu_button_set_popover (_tmp14_, _tmp16_);
	_g_object_unref0 (_tmp16_);
	_tmp17_ = self->copy_message_button;
	_tmp18_ = self->priv->_copy_folder_menu;
	gtk_menu_button_set_popover (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_popover_get_type (), GtkPopover));
	_tmp19_ = self->move_message_button;
	_tmp20_ = self->priv->_move_folder_menu;
	gtk_menu_button_set_popover (_tmp19_, G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_popover_get_type (), GtkPopover));
	_tmp21_ = self->priv->find_button;
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "find-open", G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, G_TYPE_OBJECT, GObject), "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_g_object_unref0 (mark_menu);
	_g_object_unref0 (main_menu);
	_g_object_unref0 (builder);
	return self;
}

MainToolbar*
main_toolbar_new (ApplicationConfiguration* config)
{
	return main_toolbar_construct (TYPE_MAIN_TOOLBAR, config);
}

void
main_toolbar_set_conversation_header (MainToolbar* self,
                                      GtkHeaderBar* header)
{
	GtkHeaderBar* _tmp0_;
	HdyHeaderGroup* _tmp1_;
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (header, gtk_header_bar_get_type ()));
	_tmp0_ = self->priv->conversation_header;
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
	_tmp1_ = self->priv->header_group;
	hdy_header_group_add_header_bar (_tmp1_, header);
	gtk_box_pack_start (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), G_TYPE_CHECK_INSTANCE_CAST (header, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
}

void
main_toolbar_remove_conversation_header (MainToolbar* self,
                                         GtkHeaderBar* header)
{
	HdyHeaderGroup* _tmp0_;
	GtkHeaderBar* _tmp1_;
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (header, gtk_header_bar_get_type ()));
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (header, gtk_widget_get_type (), GtkWidget));
	_tmp0_ = self->priv->header_group;
	hdy_header_group_remove_header_bar (_tmp0_, header);
	_tmp1_ = self->priv->conversation_header;
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
}

void
main_toolbar_update_trash_button (MainToolbar* self,
                                  gboolean show_trash)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	self->priv->show_trash_button = show_trash;
	main_toolbar_update_conversation_buttons (self);
}

static void
main_toolbar_update_conversation_buttons (MainToolbar* self)
{
	GtkMenuButton* _tmp0_;
	gint _tmp1_;
	GtkMenuButton* _tmp2_;
	gint _tmp3_;
	GtkMenuButton* _tmp4_;
	gint _tmp5_;
	GtkButton* _tmp6_;
	gint _tmp7_;
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	_tmp0_ = self->priv->mark_message_button;
	_tmp1_ = self->priv->_selected_conversations;
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), ngettext ("Mark conversation", "Mark conversations", (gulong) _tmp1_));
	_tmp2_ = self->copy_message_button;
	_tmp3_ = self->priv->_selected_conversations;
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), ngettext ("Add label to conversation", "Add label to conversations", (gulong) _tmp3_));
	_tmp4_ = self->move_message_button;
	_tmp5_ = self->priv->_selected_conversations;
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), ngettext ("Move conversation", "Move conversations", (gulong) _tmp5_));
	_tmp6_ = self->priv->archive_button;
	_tmp7_ = self->priv->_selected_conversations;
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), ngettext ("Archive conversation", "Archive conversations", (gulong) _tmp7_));
	if (self->priv->show_trash_button) {
		GtkButton* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GtkButton* _tmp11_;
		GtkImage* _tmp12_;
		GtkButton* _tmp13_;
		gint _tmp14_;
		_tmp8_ = self->priv->trash_delete_button;
		_tmp9_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_TRASH_CONVERSATION);
		_tmp10_ = _tmp9_;
		gtk_actionable_set_action_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_actionable_get_type (), GtkActionable), _tmp10_);
		_g_free0 (_tmp10_);
		_tmp11_ = self->priv->trash_delete_button;
		_tmp12_ = self->priv->trash_image;
		gtk_button_set_image (_tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
		_tmp13_ = self->priv->trash_delete_button;
		_tmp14_ = self->priv->_selected_conversations;
		gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget), ngettext ("Move conversation to Trash", "Move conversations to Trash", (gulong) _tmp14_));
	} else {
		GtkButton* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GtkButton* _tmp18_;
		GtkImage* _tmp19_;
		GtkButton* _tmp20_;
		gint _tmp21_;
		_tmp15_ = self->priv->trash_delete_button;
		_tmp16_ = action_window_prefix (APPLICATION_MAIN_WINDOW_ACTION_DELETE_CONVERSATION);
		_tmp17_ = _tmp16_;
		gtk_actionable_set_action_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_actionable_get_type (), GtkActionable), _tmp17_);
		_g_free0 (_tmp17_);
		_tmp18_ = self->priv->trash_delete_button;
		_tmp19_ = self->priv->delete_image;
		gtk_button_set_image (_tmp18_, G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget));
		_tmp20_ = self->priv->trash_delete_button;
		_tmp21_ = self->priv->_selected_conversations;
		gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_widget_get_type (), GtkWidget), ngettext ("Delete conversation", "Delete conversations", (gulong) _tmp21_));
	}
}

gint
main_toolbar_get_left_pane_width (MainToolbar* self)
{
	gint result;
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), 0);
	result = self->priv->_left_pane_width;
	return result;
}

void
main_toolbar_set_left_pane_width (MainToolbar* self,
                                  gint value)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	if (main_toolbar_get_left_pane_width (self) != value) {
		self->priv->_left_pane_width = value;
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY]);
	}
}

const gchar*
main_toolbar_get_account (MainToolbar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), NULL);
	_tmp0_ = self->priv->_account;
	result = _tmp0_;
	return result;
}

void
main_toolbar_set_account (MainToolbar* self,
                          const gchar* value)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	if (g_strcmp0 (value, main_toolbar_get_account (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_account);
		self->priv->_account = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_ACCOUNT_PROPERTY]);
	}
}

const gchar*
main_toolbar_get_folder (MainToolbar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), NULL);
	_tmp0_ = self->priv->_folder;
	result = _tmp0_;
	return result;
}

void
main_toolbar_set_folder (MainToolbar* self,
                         const gchar* value)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	if (g_strcmp0 (value, main_toolbar_get_folder (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_folder);
		self->priv->_folder = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_FOLDER_PROPERTY]);
	}
}

gboolean
main_toolbar_get_show_close_button (MainToolbar* self)
{
	gboolean result;
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), FALSE);
	result = self->priv->_show_close_button;
	return result;
}

void
main_toolbar_set_show_close_button (MainToolbar* self,
                                    gboolean value)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	if (main_toolbar_get_show_close_button (self) != value) {
		self->priv->_show_close_button = value;
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY]);
	}
}

gboolean
main_toolbar_get_search_open (MainToolbar* self)
{
	gboolean result;
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), FALSE);
	result = self->priv->_search_open;
	return result;
}

void
main_toolbar_set_search_open (MainToolbar* self,
                              gboolean value)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	if (main_toolbar_get_search_open (self) != value) {
		self->priv->_search_open = value;
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY]);
	}
}

gboolean
main_toolbar_get_find_open (MainToolbar* self)
{
	gboolean result;
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), FALSE);
	result = self->priv->_find_open;
	return result;
}

void
main_toolbar_set_find_open (MainToolbar* self,
                            gboolean value)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	if (main_toolbar_get_find_open (self) != value) {
		self->priv->_find_open = value;
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_FIND_OPEN_PROPERTY]);
	}
}

FolderPopover*
main_toolbar_get_copy_folder_menu (MainToolbar* self)
{
	FolderPopover* result;
	FolderPopover* _tmp0_;
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), NULL);
	_tmp0_ = self->priv->_copy_folder_menu;
	result = _tmp0_;
	return result;
}

static void
main_toolbar_set_copy_folder_menu (MainToolbar* self,
                                   FolderPopover* value)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	if (main_toolbar_get_copy_folder_menu (self) != value) {
		FolderPopover* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_copy_folder_menu);
		self->priv->_copy_folder_menu = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY]);
	}
}

FolderPopover*
main_toolbar_get_move_folder_menu (MainToolbar* self)
{
	FolderPopover* result;
	FolderPopover* _tmp0_;
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), NULL);
	_tmp0_ = self->priv->_move_folder_menu;
	result = _tmp0_;
	return result;
}

static void
main_toolbar_set_move_folder_menu (MainToolbar* self,
                                   FolderPopover* value)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	if (main_toolbar_get_move_folder_menu (self) != value) {
		FolderPopover* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_move_folder_menu);
		self->priv->_move_folder_menu = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY]);
	}
}

gint
main_toolbar_get_selected_conversations (MainToolbar* self)
{
	gint result;
	g_return_val_if_fail (IS_MAIN_TOOLBAR (self), 0);
	result = self->priv->_selected_conversations;
	return result;
}

void
main_toolbar_set_selected_conversations (MainToolbar* self,
                                         gint value)
{
	g_return_if_fail (IS_MAIN_TOOLBAR (self));
	if (main_toolbar_get_selected_conversations (self) != value) {
		self->priv->_selected_conversations = value;
		g_object_notify_by_pspec ((GObject *) self, main_toolbar_properties[MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY]);
	}
}

static void
main_toolbar_class_init (MainToolbarClass * klass,
                         gpointer klass_data)
{
	main_toolbar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MainToolbar_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_main_toolbar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_main_toolbar_set_property;
	G_OBJECT_CLASS (klass)->finalize = main_toolbar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY] = g_param_spec_int ("left-pane-width", "left-pane-width", "left-pane-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_ACCOUNT_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_ACCOUNT_PROPERTY] = g_param_spec_string ("account", "account", "account", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_FOLDER_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_FOLDER_PROPERTY] = g_param_spec_string ("folder", "folder", "folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY] = g_param_spec_boolean ("show-close-button", "show-close-button", "show-close-button", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY] = g_param_spec_boolean ("search-open", "search-open", "search-open", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_FIND_OPEN_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_FIND_OPEN_PROPERTY] = g_param_spec_boolean ("find-open", "find-open", "find-open", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY] = g_param_spec_object ("copy-folder-menu", "copy-folder-menu", "copy-folder-menu", TYPE_FOLDER_POPOVER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY] = g_param_spec_object ("move-folder-menu", "move-folder-menu", "move-folder-menu", TYPE_FOLDER_POPOVER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY, main_toolbar_properties[MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY] = g_param_spec_int ("selected-conversations", "selected-conversations", "selected-conversations", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/main-toolbar.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "folder_header", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, folder_header));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_conversations_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, search_conversations_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_menu_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, main_menu_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_header", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, conversation_header));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mark_message_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, mark_message_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "copy_message_button", FALSE, G_STRUCT_OFFSET (MainToolbar, copy_message_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "move_message_button", FALSE, G_STRUCT_OFFSET (MainToolbar, move_message_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "archive_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, archive_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "trash_delete_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, trash_delete_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "find_button", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, find_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "header_group", FALSE, MainToolbar_private_offset + G_STRUCT_OFFSET (MainToolbarPrivate, header_group));
}

static void
main_toolbar_instance_init (MainToolbar * self,
                            gpointer klass)
{
	FolderPopover* _tmp0_;
	FolderPopover* _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	self->priv = main_toolbar_get_instance_private (self);
	self->priv->_show_close_button = TRUE;
	self->priv->_search_open = FALSE;
	self->priv->_find_open = FALSE;
	_tmp0_ = folder_popover_new ();
	g_object_ref_sink (_tmp0_);
	self->priv->_copy_folder_menu = _tmp0_;
	_tmp1_ = folder_popover_new ();
	g_object_ref_sink (_tmp1_);
	self->priv->_move_folder_menu = _tmp1_;
	self->priv->show_trash_button = TRUE;
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("user-trash-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp2_);
	self->priv->trash_image = _tmp2_;
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-delete-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp3_);
	self->priv->delete_image = _tmp3_;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
main_toolbar_finalize (GObject * obj)
{
	MainToolbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_TOOLBAR, MainToolbar);
	_g_free0 (self->priv->_account);
	_g_free0 (self->priv->_folder);
	_g_object_unref0 (self->priv->_copy_folder_menu);
	_g_object_unref0 (self->priv->_move_folder_menu);
	_g_object_unref0 (self->priv->folder_header);
	_g_object_unref0 (self->priv->search_conversations_button);
	_g_object_unref0 (self->priv->main_menu_button);
	_g_object_unref0 (self->priv->conversation_header);
	_g_object_unref0 (self->priv->mark_message_button);
	_g_object_unref0 (self->copy_message_button);
	_g_object_unref0 (self->move_message_button);
	_g_object_unref0 (self->priv->archive_button);
	_g_object_unref0 (self->priv->trash_delete_button);
	_g_object_unref0 (self->priv->find_button);
	_g_object_unref0 (self->priv->header_group);
	_g_object_unref0 (self->priv->trash_image);
	_g_object_unref0 (self->priv->delete_image);
	G_OBJECT_CLASS (main_toolbar_parent_class)->finalize (obj);
}

static GType
main_toolbar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MainToolbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_toolbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainToolbar), 0, (GInstanceInitFunc) main_toolbar_instance_init, NULL };
	GType main_toolbar_type_id;
	main_toolbar_type_id = g_type_register_static (gtk_box_get_type (), "MainToolbar", &g_define_type_info, 0);
	MainToolbar_private_offset = g_type_add_instance_private (main_toolbar_type_id, sizeof (MainToolbarPrivate));
	return main_toolbar_type_id;
}

GType
main_toolbar_get_type (void)
{
	static volatile gsize main_toolbar_type_id__volatile = 0;
	if (g_once_init_enter (&main_toolbar_type_id__volatile)) {
		GType main_toolbar_type_id;
		main_toolbar_type_id = main_toolbar_get_type_once ();
		g_once_init_leave (&main_toolbar_type_id__volatile, main_toolbar_type_id);
	}
	return main_toolbar_type_id__volatile;
}

static void
_vala_main_toolbar_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	MainToolbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MAIN_TOOLBAR, MainToolbar);
	switch (property_id) {
		case MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY:
		g_value_set_int (value, main_toolbar_get_left_pane_width (self));
		break;
		case MAIN_TOOLBAR_ACCOUNT_PROPERTY:
		g_value_set_string (value, main_toolbar_get_account (self));
		break;
		case MAIN_TOOLBAR_FOLDER_PROPERTY:
		g_value_set_string (value, main_toolbar_get_folder (self));
		break;
		case MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY:
		g_value_set_boolean (value, main_toolbar_get_show_close_button (self));
		break;
		case MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY:
		g_value_set_boolean (value, main_toolbar_get_search_open (self));
		break;
		case MAIN_TOOLBAR_FIND_OPEN_PROPERTY:
		g_value_set_boolean (value, main_toolbar_get_find_open (self));
		break;
		case MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY:
		g_value_set_object (value, main_toolbar_get_copy_folder_menu (self));
		break;
		case MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY:
		g_value_set_object (value, main_toolbar_get_move_folder_menu (self));
		break;
		case MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY:
		g_value_set_int (value, main_toolbar_get_selected_conversations (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_main_toolbar_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	MainToolbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MAIN_TOOLBAR, MainToolbar);
	switch (property_id) {
		case MAIN_TOOLBAR_LEFT_PANE_WIDTH_PROPERTY:
		main_toolbar_set_left_pane_width (self, g_value_get_int (value));
		break;
		case MAIN_TOOLBAR_ACCOUNT_PROPERTY:
		main_toolbar_set_account (self, g_value_get_string (value));
		break;
		case MAIN_TOOLBAR_FOLDER_PROPERTY:
		main_toolbar_set_folder (self, g_value_get_string (value));
		break;
		case MAIN_TOOLBAR_SHOW_CLOSE_BUTTON_PROPERTY:
		main_toolbar_set_show_close_button (self, g_value_get_boolean (value));
		break;
		case MAIN_TOOLBAR_SEARCH_OPEN_PROPERTY:
		main_toolbar_set_search_open (self, g_value_get_boolean (value));
		break;
		case MAIN_TOOLBAR_FIND_OPEN_PROPERTY:
		main_toolbar_set_find_open (self, g_value_get_boolean (value));
		break;
		case MAIN_TOOLBAR_COPY_FOLDER_MENU_PROPERTY:
		main_toolbar_set_copy_folder_menu (self, g_value_get_object (value));
		break;
		case MAIN_TOOLBAR_MOVE_FOLDER_MENU_PROPERTY:
		main_toolbar_set_move_folder_menu (self, g_value_get_object (value));
		break;
		case MAIN_TOOLBAR_SELECTED_CONVERSATIONS_PROPERTY:
		main_toolbar_set_selected_conversations (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

