/* util-js.c generated by valac 0.48.2, the Vala compiler
 * generated from util-js.vala, do not modify */

/*
 * Copyright 2017,2019 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib.h>
#include <jsc/jsc.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define UTIL_JS_TYPE_CALLABLE (util_js_callable_get_type ())
#define UTIL_JS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UTIL_JS_TYPE_CALLABLE, UtilJSCallable))
#define UTIL_JS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UTIL_JS_TYPE_CALLABLE, UtilJSCallableClass))
#define UTIL_JS_IS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UTIL_JS_TYPE_CALLABLE))
#define UTIL_JS_IS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UTIL_JS_TYPE_CALLABLE))
#define UTIL_JS_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UTIL_JS_TYPE_CALLABLE, UtilJSCallableClass))

typedef struct _UtilJSCallable UtilJSCallable;
typedef struct _UtilJSCallableClass UtilJSCallableClass;
typedef struct _UtilJSCallablePrivate UtilJSCallablePrivate;
typedef struct _UtilJSParamSpecCallable UtilJSParamSpecCallable;

/**
     * Errors produced by functions in {@link Util.JS}.
     */
typedef enum  {
	UTIL_JS_ERROR_EXCEPTION,
	UTIL_JS_ERROR_TYPE
} UtilJSError;
#define UTIL_JS_ERROR util_js_error_quark ()
struct _UtilJSCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UtilJSCallablePrivate * priv;
};

struct _UtilJSCallableClass {
	GTypeClass parent_class;
	void (*finalize) (UtilJSCallable *self);
};

struct _UtilJSCallablePrivate {
	gchar* base_name;
	gchar** safe_args;
	gint safe_args_length1;
	gint _safe_args_size_;
};

struct _UtilJSParamSpecCallable {
	GParamSpec parent_instance;
};

static gint UtilJSCallable_private_offset;
static gpointer util_js_callable_parent_class = NULL;

GQuark util_js_error_quark (void);
gboolean util_js_to_bool (JSCValue* value,
                          GError** error);
void util_js_check_exception (JSCContext* context,
                              GError** error);
gdouble util_js_to_double (JSCValue* value,
                           GError** error);
gint32 util_js_to_int32 (JSCValue* value,
                         GError** error);
gchar* util_js_to_string (JSCValue* value,
                          GError** error);
JSCValue* util_js_get_property (JSCValue* value,
                                const gchar* name,
                                GError** error);
gchar* util_js_escape_string (const gchar* value);
gpointer util_js_callable_ref (gpointer instance);
void util_js_callable_unref (gpointer instance);
GParamSpec* util_js_param_spec_callable (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void util_js_value_set_callable (GValue* value,
                                 gpointer v_object);
void util_js_value_take_callable (GValue* value,
                                  gpointer v_object);
gpointer util_js_value_get_callable (const GValue* value);
GType util_js_callable_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UtilJSCallable, util_js_callable_unref)
UtilJSCallable* util_js_callable (const gchar* base_name);
UtilJSCallable* util_js_callable_new (const gchar* base_name);
UtilJSCallable* util_js_callable_construct (GType object_type,
                                            const gchar* base_name);
gchar* util_js_callable_to_string (UtilJSCallable* self);
UtilJSCallable* util_js_callable_string (UtilJSCallable* self,
                                         const gchar* value);
static inline void util_js_callable_add_param (UtilJSCallable* self,
                                 const gchar* value);
UtilJSCallable* util_js_callable_double (UtilJSCallable* self,
                                         gdouble value);
UtilJSCallable* util_js_callable_int (UtilJSCallable* self,
                                      gint value);
UtilJSCallable* util_js_callable_bool (UtilJSCallable* self,
                                       gboolean value);
static void _vala_array_add16 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void util_js_callable_finalize (UtilJSCallable * obj);
static GType util_js_callable_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

GQuark
util_js_error_quark (void)
{
	return g_quark_from_static_string ("util-js-error-quark");
}

/**
     * Returns a JSC Value as a bool.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `Boolean`.
     */
gboolean
util_js_to_bool (JSCValue* value,
                 GError** error)
{
	gboolean boolean = FALSE;
	JSCContext* _tmp3_;
	JSCContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), FALSE);
	if (!jsc_value_is_boolean (value)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Boolean object");
		_inner_error0_ = _tmp0_;
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			gboolean _tmp1_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			return _tmp1_;
		} else {
			gboolean _tmp2_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp2_;
		}
	}
	boolean = jsc_value_to_boolean (value);
	_tmp3_ = jsc_value_get_context (value);
	_tmp4_ = _tmp3_;
	util_js_check_exception (_tmp4_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			gboolean _tmp5_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			return _tmp5_;
		} else {
			gboolean _tmp6_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp6_;
		}
	}
	result = boolean;
	return result;
}

/**
     * Returns a JSC Value as a double.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
gdouble
util_js_to_double (JSCValue* value,
                   GError** error)
{
	gdouble number = 0.0;
	JSCContext* _tmp3_;
	JSCContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	gdouble result = 0.0;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), 0.0);
	if (!jsc_value_is_number (value)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Number object");
		_inner_error0_ = _tmp0_;
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			gdouble _tmp1_ = -1.0;
			g_propagate_error (error, _inner_error0_);
			return _tmp1_;
		} else {
			gdouble _tmp2_ = -1.0;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp2_;
		}
	}
	number = jsc_value_to_double (value);
	_tmp3_ = jsc_value_get_context (value);
	_tmp4_ = _tmp3_;
	util_js_check_exception (_tmp4_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			gdouble _tmp5_ = -1.0;
			g_propagate_error (error, _inner_error0_);
			return _tmp5_;
		} else {
			gdouble _tmp6_ = -1.0;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp6_;
		}
	}
	result = number;
	return result;
}

/**
     * Returns a JSC Value as an int32.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
gint32
util_js_to_int32 (JSCValue* value,
                  GError** error)
{
	gint32 number = 0;
	JSCContext* _tmp3_;
	JSCContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	gint32 result = 0;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), 0);
	if (!jsc_value_is_number (value)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Number object");
		_inner_error0_ = _tmp0_;
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			gint32 _tmp1_ = -1;
			g_propagate_error (error, _inner_error0_);
			return _tmp1_;
		} else {
			gint32 _tmp2_ = -1;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp2_;
		}
	}
	number = jsc_value_to_int32 (value);
	_tmp3_ = jsc_value_get_context (value);
	_tmp4_ = _tmp3_;
	util_js_check_exception (_tmp4_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			gint32 _tmp5_ = -1;
			g_propagate_error (error, _inner_error0_);
			return _tmp5_;
		} else {
			gint32 _tmp6_ = -1;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp6_;
		}
	}
	result = number;
	return result;
}

/**
     * Returns a JSC Value as a string.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `String`.
     */
gchar*
util_js_to_string (JSCValue* value,
                   GError** error)
{
	gchar* str = NULL;
	gchar* _tmp1_;
	JSCContext* _tmp2_;
	JSCContext* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), NULL);
	if (!jsc_value_is_string (value)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS String object");
		_inner_error0_ = _tmp0_;
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = jsc_value_to_string (value);
	str = _tmp1_;
	_tmp2_ = jsc_value_get_context (value);
	_tmp3_ = _tmp2_;
	util_js_check_exception (_tmp3_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (str);
			return NULL;
		} else {
			_g_free0 (str);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = str;
	return result;
}

/**
     * Returns the value of an object property.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not an object or does not contain the named property.
     */
inline JSCValue*
util_js_get_property (JSCValue* value,
                      const gchar* name,
                      GError** error)
{
	JSCValue* property = NULL;
	JSCValue* _tmp1_;
	JSCContext* _tmp2_;
	JSCContext* _tmp3_;
	GError* _inner_error0_ = NULL;
	JSCValue* result = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (value, jsc_value_get_type ()), NULL);
	g_return_val_if_fail (name != NULL, NULL);
	if (!jsc_value_is_object (value)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Object");
		_inner_error0_ = _tmp0_;
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = jsc_value_object_get_property (value, name);
	property = _tmp1_;
	_tmp2_ = jsc_value_get_context (value);
	_tmp3_ = _tmp2_;
	util_js_check_exception (_tmp3_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (property);
			return NULL;
		} else {
			_g_object_unref0 (property);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = property;
	return result;
}

/**
     * Checks an JS exception returned from a JSC call.
     *
     * If the given context has a current exception, it will cleared
     * and a {@link Util.JS.Error} will be thrown.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

inline void
util_js_check_exception (JSCContext* context,
                         GError** error)
{
	JSCException* exception = NULL;
	JSCException* _tmp0_;
	JSCException* _tmp1_;
	JSCException* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (context, jsc_context_get_type ()));
	_tmp0_ = jsc_context_get_exception (context);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	exception = _tmp1_;
	_tmp2_ = exception;
	if (_tmp2_ != NULL) {
		JSCException* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		GError* _tmp7_;
		jsc_context_clear_exception (context);
		_tmp3_ = exception;
		_tmp4_ = jsc_exception_to_string (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_error_new (UTIL_JS_ERROR, UTIL_JS_ERROR_EXCEPTION, "JS exception thrown: %s", _tmp5_);
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp5_);
		_inner_error0_ = _tmp7_;
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (exception);
			return;
		} else {
			_g_object_unref0 (exception);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_g_object_unref0 (exception);
}

/**
     * Escapes a string so as to be safe to use as a JS string literal.
     *
     * This does not append opening or closing quotes.
     */
static gboolean
string_valid_char (const gchar* self,
                   gint index)
{
	guint8 c = 0U;
	guint8 _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = ((guint8*) self)[index];
	c = _tmp0_;
	if (((gint) c) == 0x00) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp3_ = FALSE;
		if (((gint) c) >= 0x80) {
			_tmp3_ = ((gint) c) < 0xc2;
		} else {
			_tmp3_ = FALSE;
		}
		_tmp2_ = _tmp3_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = ((gint) c) >= 0xf5;
	}
	if (_tmp1_) {
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	result = g_utf8_get_char (((gchar*) self) + index);
	return result;
}

static guint8*
g_string_get_data (GString* self,
                   gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->str;
	res = (guint8*) _tmp0_;
	res_length1 = -1;
	_res_size_ = res_length1;
	res_length1 = (gint) self->len;
	_tmp1_ = res;
	_tmp1__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

gchar*
util_js_escape_string (const gchar* value)
{
	GString* builder = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GString* _tmp2_;
	GString* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
	gint _tmp20_ = 0;
	guint8* _tmp21_;
	gint _tmp21__length1;
	gchar* _tmp22_;
	gchar* result = NULL;
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = strlen (value);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_string_sized_new ((gsize) _tmp1_);
	builder = _tmp2_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gint _tmp6_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = strlen (value);
				_tmp6_ = _tmp5_;
				if (!(i < _tmp6_)) {
					break;
				}
				if (string_valid_char (value, i)) {
					gunichar c = 0U;
					c = string_get_char (value, (glong) i);
					switch (c) {
						case '\x00':
						{
							GString* _tmp7_;
							_tmp7_ = builder;
							g_string_append (_tmp7_, "\x00");
							break;
						}
						case '\'':
						{
							GString* _tmp8_;
							_tmp8_ = builder;
							g_string_append (_tmp8_, "\\\'");
							break;
						}
						case '"':
						{
							GString* _tmp9_;
							_tmp9_ = builder;
							g_string_append (_tmp9_, "\\\"");
							break;
						}
						case '\\':
						{
							GString* _tmp10_;
							_tmp10_ = builder;
							g_string_append (_tmp10_, "\\\\");
							break;
						}
						case '\n':
						{
							GString* _tmp11_;
							_tmp11_ = builder;
							g_string_append (_tmp11_, "\\n");
							break;
						}
						case '\r':
						{
							GString* _tmp12_;
							_tmp12_ = builder;
							g_string_append (_tmp12_, "\\r");
							break;
						}
						case '\x0b':
						{
							GString* _tmp13_;
							_tmp13_ = builder;
							g_string_append (_tmp13_, "\x0b");
							break;
						}
						case '\t':
						{
							GString* _tmp14_;
							_tmp14_ = builder;
							g_string_append (_tmp14_, "\\t");
							break;
						}
						case '\b':
						{
							GString* _tmp15_;
							_tmp15_ = builder;
							g_string_append (_tmp15_, "\\b");
							break;
						}
						case '\f':
						{
							GString* _tmp16_;
							_tmp16_ = builder;
							g_string_append (_tmp16_, "\\f");
							break;
						}
						default:
						{
							GString* _tmp17_;
							_tmp17_ = builder;
							g_string_append_unichar (_tmp17_, c);
							break;
						}
					}
				}
			}
		}
	}
	_tmp18_ = builder;
	_tmp19_ = g_string_get_data (_tmp18_, &_tmp20_);
	_tmp19__length1 = _tmp20_;
	_tmp21_ = _tmp19_;
	_tmp21__length1 = _tmp19__length1;
	_tmp22_ = g_strdup ((const gchar*) _tmp21_);
	result = _tmp22_;
	_g_string_free0 (builder);
	return result;
}

/**
     * Convenience method for returning a new Callable instance.
     */
UtilJSCallable*
util_js_callable (const gchar* base_name)
{
	UtilJSCallable* _tmp0_;
	UtilJSCallable* result = NULL;
	g_return_val_if_fail (base_name != NULL, NULL);
	_tmp0_ = util_js_callable_new (base_name);
	result = _tmp0_;
	return result;
}

static inline gpointer
util_js_callable_get_instance_private (UtilJSCallable* self)
{
	return G_STRUCT_MEMBER_P (self, UtilJSCallable_private_offset);
}

UtilJSCallable*
util_js_callable_construct (GType object_type,
                            const gchar* base_name)
{
	UtilJSCallable* self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (base_name != NULL, NULL);
	self = (UtilJSCallable*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (base_name);
	_g_free0 (self->priv->base_name);
	self->priv->base_name = _tmp0_;
	return self;
}

UtilJSCallable*
util_js_callable_new (const gchar* base_name)
{
	return util_js_callable_construct (UTIL_JS_TYPE_CALLABLE, base_name);
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp19_ = res;
		_tmp20_ = str_array[0];
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
		ptr = _tmp21_;
		{
			gboolean _tmp22_ = FALSE;
			i = 1;
			_tmp22_ = TRUE;
			while (TRUE) {
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp24_ = ptr;
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
				ptr = _tmp25_;
				_tmp27_ = str_array[i];
				if (_tmp27_ != NULL) {
					const gchar* _tmp28_;
					_tmp28_ = str_array[i];
					_tmp26_ = (const gchar*) _tmp28_;
				} else {
					_tmp26_ = "";
				}
				_tmp29_ = ptr;
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
				ptr = _tmp30_;
			}
		}
		_tmp31_ = res;
		res = NULL;
		result = (gchar*) _tmp31_;
		return result;
	} else {
		gchar* _tmp32_;
		_tmp32_ = g_strdup ("");
		result = _tmp32_;
		return result;
	}
}

gchar*
util_js_callable_to_string (UtilJSCallable* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result = NULL;
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
	_tmp0_ = self->priv->base_name;
	_tmp1_ = g_strconcat (_tmp0_, "(", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->safe_args;
	_tmp3__length1 = self->priv->safe_args_length1;
	_tmp4_ = _vala_g_strjoinv (",", _tmp3_, (gint) _tmp3__length1);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat (_tmp7_, ");", NULL);
	_tmp9_ = _tmp8_;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp2_);
	result = _tmp9_;
	return result;
}

static gpointer
_util_js_callable_ref0 (gpointer self)
{
	return self ? util_js_callable_ref (self) : NULL;
}

UtilJSCallable*
util_js_callable_string (UtilJSCallable* self,
                         const gchar* value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	UtilJSCallable* _tmp6_;
	UtilJSCallable* result = NULL;
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
	g_return_val_if_fail (value != NULL, NULL);
	_tmp0_ = util_js_escape_string (value);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat ("\"", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, "\"", NULL);
	_tmp5_ = _tmp4_;
	util_js_callable_add_param (self, _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	_tmp6_ = _util_js_callable_ref0 (self);
	result = _tmp6_;
	return result;
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

UtilJSCallable*
util_js_callable_double (UtilJSCallable* self,
                         gdouble value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	UtilJSCallable* _tmp2_;
	UtilJSCallable* result = NULL;
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
	_tmp0_ = double_to_string (value);
	_tmp1_ = _tmp0_;
	util_js_callable_add_param (self, _tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = _util_js_callable_ref0 (self);
	result = _tmp2_;
	return result;
}

UtilJSCallable*
util_js_callable_int (UtilJSCallable* self,
                      gint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	UtilJSCallable* _tmp2_;
	UtilJSCallable* result = NULL;
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
	_tmp0_ = g_strdup_printf ("%i", value);
	_tmp1_ = _tmp0_;
	util_js_callable_add_param (self, _tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = _util_js_callable_ref0 (self);
	result = _tmp2_;
	return result;
}

UtilJSCallable*
util_js_callable_bool (UtilJSCallable* self,
                       gboolean value)
{
	const gchar* _tmp0_ = NULL;
	UtilJSCallable* _tmp1_;
	UtilJSCallable* result = NULL;
	g_return_val_if_fail (UTIL_JS_IS_CALLABLE (self), NULL);
	if (value) {
		_tmp0_ = "true";
	} else {
		_tmp0_ = "false";
	}
	util_js_callable_add_param (self, _tmp0_);
	_tmp1_ = _util_js_callable_ref0 (self);
	result = _tmp1_;
	return result;
}

static void
_vala_array_add16 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static inline void
util_js_callable_add_param (UtilJSCallable* self,
                            const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (UTIL_JS_IS_CALLABLE (self));
	g_return_if_fail (value != NULL);
	_tmp0_ = g_strdup (value);
	_vala_array_add16 (&self->priv->safe_args, &self->priv->safe_args_length1, &self->priv->_safe_args_size_, _tmp0_);
}

static void
util_js_value_callable_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
util_js_value_callable_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		util_js_callable_unref (value->data[0].v_pointer);
	}
}

static void
util_js_value_callable_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = util_js_callable_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
util_js_value_callable_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
util_js_value_callable_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		UtilJSCallable * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = util_js_callable_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
util_js_value_callable_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	UtilJSCallable ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = util_js_callable_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
util_js_param_spec_callable (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	UtilJSParamSpecCallable* spec;
	g_return_val_if_fail (g_type_is_a (object_type, UTIL_JS_TYPE_CALLABLE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
util_js_value_get_callable (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTIL_JS_TYPE_CALLABLE), NULL);
	return value->data[0].v_pointer;
}

void
util_js_value_set_callable (GValue* value,
                            gpointer v_object)
{
	UtilJSCallable * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTIL_JS_TYPE_CALLABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTIL_JS_TYPE_CALLABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		util_js_callable_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		util_js_callable_unref (old);
	}
}

void
util_js_value_take_callable (GValue* value,
                             gpointer v_object)
{
	UtilJSCallable * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTIL_JS_TYPE_CALLABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTIL_JS_TYPE_CALLABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		util_js_callable_unref (old);
	}
}

static void
util_js_callable_class_init (UtilJSCallableClass * klass,
                             gpointer klass_data)
{
	util_js_callable_parent_class = g_type_class_peek_parent (klass);
	((UtilJSCallableClass *) klass)->finalize = util_js_callable_finalize;
	g_type_class_adjust_private_offset (klass, &UtilJSCallable_private_offset);
}

static void
util_js_callable_instance_init (UtilJSCallable * self,
                                gpointer klass)
{
	gchar** _tmp0_;
	self->priv = util_js_callable_get_instance_private (self);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	self->priv->safe_args = _tmp0_;
	self->priv->safe_args_length1 = 0;
	self->priv->_safe_args_size_ = self->priv->safe_args_length1;
	self->ref_count = 1;
}

static void
util_js_callable_finalize (UtilJSCallable * obj)
{
	UtilJSCallable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UTIL_JS_TYPE_CALLABLE, UtilJSCallable);
	g_signal_handlers_destroy (self);
	_g_free0 (self->priv->base_name);
	self->priv->safe_args = (_vala_array_free (self->priv->safe_args, self->priv->safe_args_length1, (GDestroyNotify) g_free), NULL);
}

/**
     * A class for constructing a well formed, safe, invokable JS call.
     */
static GType
util_js_callable_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { util_js_value_callable_init, util_js_value_callable_free_value, util_js_value_callable_copy_value, util_js_value_callable_peek_pointer, "p", util_js_value_callable_collect_value, "p", util_js_value_callable_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UtilJSCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) util_js_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilJSCallable), 0, (GInstanceInitFunc) util_js_callable_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType util_js_callable_type_id;
	util_js_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UtilJSCallable", &g_define_type_info, &g_define_type_fundamental_info, 0);
	UtilJSCallable_private_offset = g_type_add_instance_private (util_js_callable_type_id, sizeof (UtilJSCallablePrivate));
	return util_js_callable_type_id;
}

GType
util_js_callable_get_type (void)
{
	static volatile gsize util_js_callable_type_id__volatile = 0;
	if (g_once_init_enter (&util_js_callable_type_id__volatile)) {
		GType util_js_callable_type_id;
		util_js_callable_type_id = util_js_callable_get_type_once ();
		g_once_init_leave (&util_js_callable_type_id__volatile, util_js_callable_type_id);
	}
	return util_js_callable_type_id__volatile;
}

gpointer
util_js_callable_ref (gpointer instance)
{
	UtilJSCallable * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
util_js_callable_unref (gpointer instance)
{
	UtilJSCallable * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		UTIL_JS_CALLABLE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

